program Commerce;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Forms, Interfaces,
  fonctions_startibx,
  fonctions_system,
  fonctions_dbcomponents,
  u_multidonnees,
  u_multidata,
  fonctions_init,
  fonctions_manibx,
  fonctions_manbase,
  fonctions_objets_dynamiques,
  IniFiles,
  U_FormMainIni,
  fonctions_dialogs,
  fonctions_forms,
  LCLType,
  U_SeleArticle in 'U_SeleArticle.pas' {F_SeleArticle},
  U_Client in 'U_Client.pas' {F_Client},
  U_Composant in 'U_Composant.pas' {F_Composant},
  U_ConstMessage in 'U_ConstMessage.pas',
  U_DmDonn in 'U_DmDonn.pas' {M_Donn},
  U_Famille in 'U_Famille.pas' {F_Famille},
  U_Modalite in 'U_Modalite.pas' {F_Modalite},
  U_CodePostal in 'U_CodePostal.pas' {F_CodePostal},
  U_Representant in 'U_Representant.pas' {F_Repr},
  U_TVA in 'U_TVA.pas' {F_TVA},
  U_comm in 'U_comm.pas' {F_Comm},
  U_Famillevente in 'U_Famillevente.pas' {F_Famillevente},
  U_ComposeArticle in 'U_ComposeArticle.pas' {F_ComposeArticle},
  U_Civilite in 'U_Civilite.pas' {F_Civilite},
  U_DmCompose in 'U_DmCompose.pas' {M_DmCompose},
  U_Structure in 'U_Structure.pas' {F_Structure},
  U_Comportement in 'U_Comportement.pas' {F_Comportement},
  U_Pays in 'U_Pays.pas' {F_Pays},
  U_DmArticle in 'U_DmArticle.pas' {M_Article: TDataModule};

{$IFNDEF FPC}
{$R *.res}
{$R WindowsXP.res}
{$ENDIF}

var FINI : TInifile;
    gbm_Database : TFWBaseMode;
begin
  Application.Initialize;
  Application.Title := 'Créer un article';

  doShowWorking( 'Créer un article' );
  gs_DefaultDatabase:=ExtractSubDir(GetAppDir)+'Compose.fdb';
  FINI := TIniFile.Create(ExtractSubDir(GetAppDir)+fs_GetSoftName+CST_EXTENSION_INI);
  gbm_Database := bmFirebird;
  DMModuleSources := TDMModuleSources.Create(Application);

  with DMModuleSources,Sources.Add do
   fb_LoadData(FINI,'Database',Sources [ 0 ], gbm_Database, DMModuleSources, CST_SQL_DRIVER_FIREBIRD,'', gs_DefaultDatabase, 'SYSDBA','masterkey');

  p_InitRegisterForms;

  gs_DefaultDatabase:=ExtractSubDir(GetAppDir)+'Compose.fdb';

  Application.CreateForm(TM_Donn, M_Donn);
  Application.CreateForm(TM_Article, M_Article);
  Application.CreateForm(TM_DmCompose, M_DmCompose);
  Application.CreateForm(TF_Structure, F_Structure);
{  if gb_MainFormIniDirectAccessOnServer Then
    with M_Article do
      Begin
        zq_Article1.CursorLocation := clUseServer ;
        zq_Article1.CursorType     := ctKeySet ;
        zq_Article2.CursorLocation := clUseServer ;
        zq_Article2.CursorType     := ctKeySet ;
        zq_Article3.CursorLocation := clUseServer ;
        zq_Article3.CursorType     := ctKeySet ;
        zq_Article4.CursorLocation := clUseServer ;
        zq_Article4.CursorType     := ctKeySet ;
        zq_Article5.CursorLocation := clUseServer ;
        zq_Article5.CursorType     := ctKeySet ;
        zq_Article6.CursorLocation := clUseServer ;
        zq_Article6.CursorType     := ctKeySet ;
      End ;
  finally
  end;                }
  p_RegisterClasses ([TF_Modalite, TF_Client, TF_Composant,
                      TF_Famille,
                      TF_CodePostal, TF_TVA, TF_Repr,
                      TF_Comm,
                      TF_Famillevente,
                      TF_SeleArticle,
                      TF_Civilite, TF_Structure, TF_Comportement, TF_ComposeArticle,
                      TF_Pays]);


  Application.Run;
end.
